#include <math.h>
#include <list>
#include <fstream>
#include <stdlib.h>

#include "global.h"
#include "game.h"
#include "mfobject.h"
#include "images.h"
using namespace ol;
using namespace std;
typedef list<MFObject*>::iterator objiter;


int dialog() {
	// Protait of King and peon needed. They'll talk, King decides on what he want (you do :P). Peon protests about the cost, king attacks, gets 1 gold, and rest is collected in game
	int cost = 0, item = 0;
	bool running = true;
	string text;
	Rgba selected(1.0, 1.0, 0.0), unselected(1.0, 1.0, 1.0), king(0.5, 0.5, 1.0), peon(1.0, 0.5, 0.5);
	// Display first part of the dialog
	while (running) {
		Canvas::Fill(Rgba::BLACK);
		text = "My liege, we have gather all the gold as you requested.";
		game.SetColor(peon);
		game.Print(text, TEXT_X(10), TEXT_Y(30));
		text = "Nice work my peons. I am most pleased.";
		game.SetColor(king);
		game.Print(text, TEXT_X(10), TEXT_Y(60));
		text = "Eh!? Did you just call us peons?";
		game.SetColor(peon);
		game.Print(text, TEXT_X(10), TEXT_Y(90));
		text = "Yes I did, now hand the gold over!";
		game.SetColor(king);
		game.Print(text, TEXT_X(10), TEXT_Y(120));
		text = "No! Not until you tell us why you wanted all the gold in the kingdom!";
		game.SetColor(peon);
		game.Print(text, TEXT_X(10), TEXT_Y(150));
		text = "Ah! So you want to know? Well then. I want to get...";
		game.SetColor(king);
		game.Print(text, TEXT_X(10), TEXT_Y(180));
		text = "Select what you want the king to have:";
		game.SetColor(Rgba::WHITE);
		game.Print(text, TEXT_X(10), TEXT_Y(250));
		
		text = "...a banana shooting gun to shoot spam mail.";
		game.SetColor(((item == 0) ? selected : unselected));
		game.Print(text, TEXT_X(10), TEXT_Y(280));
		text = "...the newest game system, complete with a home theater system.";
		game.SetColor(((item == 1) ? selected : unselected));
		game.Print(text, TEXT_X(10), TEXT_Y(310));
		text = "...a new wing for the castle.";
		game.SetColor(((item == 2) ? selected : unselected));
		game.Print(text, TEXT_X(10), TEXT_Y(340));
		
		if (keypressed()) {
			int k = readkey() >> 8;
			switch (k) {
			case KEY_DOWN:
				item++;
				if (item > 2) item = 2;
				break;
			case KEY_UP:
				item--;
				if (item < 0) item = 0;
				break;
			case KEY_ENTER:
				running = false;
				break;
			case KEY_ESC:
				game.SetColor(Rgba::WHITE);
				return -1;
			}
		}
		Canvas::Refresh();
	}
	// Set cost
	switch (item) {
	case 2:
		cost += 70;
	case 1:
		cost += 49;
	case 0:
		cost += 1;
	}
	running = true;
	while (running) {
		Canvas::Fill(Rgba::BLACK);
		text = "WHAT!? That costs " + ToString(cost + 7) + " quinces of gold! We'll be completely broke!";
		game.SetColor(peon);
		game.Print(text, TEXT_X(10), TEXT_Y(30));
		text = "I'm the king, you all do as I say, I'll take that quince from you, and kill you all! *WACK!*";
		game.SetColor(king);
		game.Print(text, TEXT_X(10), TEXT_Y(60));
		text = "Ah! I'm warning the others!";
		game.SetColor(peon);
		game.Print(text, TEXT_X(10), TEXT_Y(90));
		
		if (keypressed()) {
			running = false;
		}
		Canvas::Refresh();
	}
	// Reset font color
	game.SetColor(Rgba::WHITE);
	return cost;
}

void play_game(void) {
	int gold_total = dialog(); // Dialog sets the amount of gold that's needed
	if (gold_total == -1) return;
	int health = 0, score = 0, gold_left = 0, peons_left = 0, peons_killed = 0;
	MFObject *king; // Just to keep track of him in the mess
	MFObject *nObject; // New object that was created someplace
	list<MFObject*> objects; // Includes the king
	bool running = true, menu = false;
	int x, y, px, py;
	string status;
	Vec2D speed(0.0, 0.0);
	// Map bitmaps
	Bitmap wall("media/wall.png");
	Bitmap plain("media/ground.png");
	Bitmap sand("media/sand.png");
	Bitmap ice("media/ice.png");
	// Map size
	int **map;
	// 0 wall, 1 plain ground, 2 sand, 3 ice
	OlLog("++++++++"); // Mark where I'm loggin stuff at, just in case
	
	map = new int*[MAP_X];
	
	for (x = 0; x < MAP_X; x++) {
		map[x] = new int[MAP_Y];
		for (y = 0; y < MAP_Y; y++) {
			map[x][y] = 0;
		}
	}
	
	// Read map data
	ifstream mapdata;
	mapdata.open("media/map.txt");
	string mapline;
	y = 0;
	while (!mapdata.eof()) {
		mapdata >> mapline;
		if (y < MAP_Y) {
			for (x = 0; x < MAP_X && x < (int)mapline.length(); x++) {
				int i = (mapline.data()[x] - '0');
				switch (i) {
				case 0:
				case 1:
				case 2:
				case 3:
					map[x][y] = (i);
				}
			}
			y++;
		}
	}
	mapdata.close();
	// Populate objects
	king = new MFObject(0, Vec2D(1600, 100));
	objects.push_back(king);
	// Make five quinces of gold, then make 3 peons without gold, then however many are needed to have gold_total. Yes, there's 5 more quinces than needed.
	for (x = 0; x < 5; x++) {
		nObject = new MFObject(2, Vec2D(x*512+512, 2755));
		objects.push_front(nObject);
	}
	for (x = 0; x < 3; x++) {
		// Get random location, make sure there's no wall, and plot a peon there
		do {
			px = rand()%48+1;
			py = rand()%40+9;
		} while (map[px][py] == 0);
		px *= 64;
		py *= 64;
		nObject = new MFObject(1, Vec2D(px, py), false);
		if (!nObject) {
			OlLog("Error creating peon!");
			break;
		}
		objects.push_back(nObject);
		peons_left++;
		
	}
	OlLog("Object size after none gold peons: " + ToString(objects.size()));
	for (x = 0; x < gold_total; x++) {
		// Get random location, make sure there's no wall, and plot a peon there
		do {
			px = rand()%48+1;
			py = rand()%40+9;
		} while (map[px][py] == 0);
		px *= 64;
		py *= 64;
		nObject = new MFObject(1, Vec2D(px, py), true);
		if (!nObject) {
			OlLog("Error creating peon!");
			break;
		}
		objects.push_back(nObject);
		peons_left++;
	}
	OlLog("Object size after gold peons: " + ToString(objects.size()));
	gold_total += 5;
	
	FpsCounter::Start(60.0);
	while (running) {
		while( keypressed()) {
			if(readkey() >> 8 == KEY_P) {
				FpsCounter::Pause();
				bool pause = true;
				while( pause ) {
					Canvas::Fill(Rgba::BLACK);
					// display pause text
					string p = "Paused";
					game.Print(p, TEXT_X(v_w - game.Width(p)/text_scale_x)/2, TEXT_Y(v_h - game.Height(p)/text_scale_y)/2);
					Canvas::Refresh();
					while( keypressed()) {
						if(readkey() >> 8 == KEY_P)
							pause = false;
					}
				}
				FpsCounter::Resume();
			}
		}
		if (key[KEY_ESC]) {
			running = false;
			menu = true;
		}
		FpsCounter::NewFrameStarted();
		// Do Collision
		for (objiter i = objects.begin(); i != objects.end(); i++) {
			for (objiter j = i; j != objects.end(); j++) {
				if (j != i) {// Couldn't get i+1 working for some reason...
					(*i)->doCollide(*j);
					(*j)->doCollide(*i);
				}
			}
		}
		
		// Do Logic
		Canvas::Fill(Rgba::BLACK); // This is up here because of debugging reasons
		Transforms::PushPlacement();
		for(objiter i = objects.begin(); i != objects.end(); ) {
			if (king == *i) {
				gold_left = gold_total - king->gold();
				health = king->health();
				score = king->score();
			}
			if ((*i)->doLogic(map)) {
				nObject = (*i)->spawnObject();
				if (nObject) objects.push_front(nObject);
				i++;
			}
			else {
				if (king == *i) {
					// King died, or somehow appeared where he wasn't supposed to be
					running = false;
					king = NULL;
				}
				if ((*i)->isPeon()) {
					peons_left--;
					peons_killed++;
				}
				delete (*i);
				i = objects.erase(i);
			}
		}
		score += peons_killed*10000;
		if (gold_left == 0 && peons_left == 0) {
			// Only the king is left
			running = false;
		}
		// if running is false, we should be leaving the loop anyway
		if (running) {
			for (x = 0; x < MAP_X; x++) {
				for (y = 0; y < MAP_Y; y++) {
					switch (map[x][y]) {
					case 1:
						plain.Blit(x*64, y*64);
						break;
					case 2:
						sand.Blit(x*64, y*64);
						break;
					case 3:
						plain.Blit(x*64, y*64); // Because ice is transparent
						ice.Blit(x*64, y*64);
						break;
					default:
						wall.Blit(x*64, y*64);
						break;
					}
				}
			}
			// Draw Objects
			for(objiter i = objects.begin(); i != objects.end(); i++) {
				(*i)->draw();
			}
			Transforms::PopPlacement();
			
			// Draw HUD
			Rect(0, 0, v_w, 30).Draw(Rgba::BLACK);
			status = "Score: " + ToString(score)
			+ ", Health: " + ToString(health)
			+ ", Gold Left: " + ToString(gold_left)
			+ ", Peons Left: " + ToString(peons_left);
			game.Print(status, TEXT_X(v_w - game.Width(status)/text_scale_x)/2, TEXT_Y(23));
			Canvas::Refresh();
		} else {
			Transforms::PopPlacement();
		}
	}
	for (objiter i = objects.begin(); i !=objects.end(); i++) {
		delete (*i);
	}
	objects.clear();
	if (!menu) {
		// Display final score
		running = true;
		while (running) {
			Canvas::Fill(Rgba::BLACK);
			if (keypressed() && (readkey() >> 8) == KEY_ENTER) {
				running = false;
			}
			string text = "Game Over";
			game.Print(text, TEXT_X(v_w - game.Width(text)/text_scale_x)/2, TEXT_Y(200));
			if (health > 0) text = "You won! ";
			else text = "You lost! ";
			game.Print(text, TEXT_X(v_w - game.Width(text)/text_scale_x)/2, TEXT_Y(250));
			text = "But since you were the bad guy, this game is lose/lose anyway...";
			game.Print(text, TEXT_X(v_w - game.Width(text)/text_scale_x)/2, TEXT_Y(300));
			text = "Anyway, your final score is " + ToString(score);
			game.Print(text, TEXT_X(v_w - game.Width(text)/text_scale_x)/2, TEXT_Y(350));
			text = "Press Enter to Continue";
			game.Print(text, TEXT_X(v_w - game.Width(text)/text_scale_x)/2, TEXT_Y(450));
			// Display score, and make a commit about the game not really caring if you won or not, tell them if you did anyway
			Canvas::Refresh();
		}
	}
}
