#include "timer.h"

#ifndef WIN32
	LONG_LONG Timer::secondsToMicro = 1000000.0;
#else
	LARGE_INTEGER Timer::currentTime;
	LARGE_INTEGER Timer::frequency;
#endif

void Timer::Intialize(){
	#ifdef WIN32
		QueryPerformanceFrequency(&frequency);
	#endif
}


LONG_LONG Timer::GetCurrentTime(){
	#ifdef WIN32
		QueryPerformanceCounter(&Timer::currentTime);

		return (LONG_LONG)Timer::currentTime.QuadPart;
	#else
		timeval internalTime;
		gettimeofday(&internalTime, NULL);

		return (LONG_LONG)internalTime.tv_sec*Timer::secondsToMicro + internalTime.tv_usec;
	#endif
}

LONG_LONG Timer::GetPrecision(){
	#ifdef WIN32
		return (LONG_LONG)Timer::frequency.QuadPart;
	#else
		return Timer::secondsToMicro;
	#endif
}

LONG_LONG Timer::GetElapsedTimeMsec(LONG_LONG lastTime){
	#ifdef WIN32
		return Timer::GetCurrentTime() - lastTime;
	#else
		return Timer::GetCurrentTime() - lastTime;
	#endif
}

float Timer::GetElapsedTimeSeconds(LONG_LONG lastTime){
	#ifdef WIN32
		return float(Timer::GetCurrentTime() - lastTime)/Timer::frequency.QuadPart;
	#else
		return float(Timer::GetCurrentTime() - lastTime)/Timer::secondsToMicro;
	#endif
}

void Timer::StartStopwatch(){
	start = Timer::GetCurrentTime();
}

LONG_LONG Timer::GetStopwatchTimeMsec(){
	#ifdef WIN32
		return Timer::GetCurrentTime() - start;
	#else
		return Timer::GetCurrentTime() - start;
	#endif
}

float Timer::GetStopwatchTimeSec(){
	#ifdef WIN32
		return float(Timer::GetCurrentTime() - start)/Timer::frequency.QuadPart;
	#else
		return float(Timer::GetCurrentTime() - start)/Timer::secondsToMicro;
	#endif
}
